VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSCOMM32.OCX"
Begin VB.Form SendProgramEEPROM 
   Caption         =   "Send and Program EEPROM"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   630
   ClientWidth     =   4680
   ControlBox      =   0   'False
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   WindowState     =   2  'Maximized
   Begin VB.Frame fraEEPROM 
      Caption         =   "EEPROM"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2295
      Left            =   240
      TabIndex        =   0
      Top             =   240
      Width           =   3495
      Begin VB.TextBox txtAddress 
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   9.75
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   285
         Left            =   240
         MaxLength       =   5
         TabIndex        =   6
         Top             =   720
         Width           =   1455
      End
      Begin VB.CommandButton cmdRead 
         Caption         =   "Read"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   9.75
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   375
         Left            =   2160
         TabIndex        =   3
         Top             =   840
         Width           =   1095
      End
      Begin VB.CommandButton cmdWrite 
         Caption         =   "Write"
         Enabled         =   0   'False
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   9.75
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   375
         Left            =   2160
         TabIndex        =   2
         Top             =   1440
         Width           =   1095
      End
      Begin VB.TextBox txtValue 
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   9.75
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   285
         Left            =   240
         MaxLength       =   5
         TabIndex        =   1
         Top             =   1680
         Width           =   1455
      End
      Begin VB.Label Label1 
         Caption         =   "Address"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   9.75
            Charset         =   0
            Weight          =   700
            Underline       =   -1  'True
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   255
         Left            =   240
         TabIndex        =   5
         Top             =   480
         Width           =   1215
      End
      Begin VB.Label Label2 
         Caption         =   "Value"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   9.75
            Charset         =   0
            Weight          =   700
            Underline       =   -1  'True
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   375
         Left            =   240
         TabIndex        =   4
         Top             =   1440
         Width           =   1215
      End
   End
   Begin VB.Timer TimerEEPROM 
      Enabled         =   0   'False
      Interval        =   100
      Left            =   960
      Top             =   2640
   End
   Begin MSCommLib.MSComm MSComm1 
      Left            =   240
      Top             =   2640
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      DTREnable       =   -1  'True
      BaudRate        =   19200
      InputMode       =   1
   End
   Begin VB.Label Label3 
      Caption         =   "Button is disabled; use with care; If you write to an EEPROM address incorrectly, you may affect the operation of the 3DM-G!"
      Height          =   855
      Left            =   5880
      TabIndex        =   7
      Top             =   1440
      Width           =   3255
   End
   Begin VB.Line Line3 
      BorderColor     =   &H000000FF&
      BorderWidth     =   3
      X1              =   3840
      X2              =   4080
      Y1              =   1800
      Y2              =   2040
   End
   Begin VB.Line Line2 
      BorderColor     =   &H000000FF&
      BorderWidth     =   3
      X1              =   3840
      X2              =   4080
      Y1              =   1800
      Y2              =   1560
   End
   Begin VB.Line Line1 
      BorderColor     =   &H000000FF&
      BorderWidth     =   3
      X1              =   3840
      X2              =   5760
      Y1              =   1800
      Y2              =   1800
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuReturn 
         Caption         =   "&Return"
      End
   End
End
Attribute VB_Name = "SendProgramEEPROM"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub cmdRead_Click()
'test for address
If Trim(txtAddress.Text) = "" Then
    'msg
    MsgBox "No address has been entered!", vbOKOnly, MBT
    'exit
    Exit Sub
End If
'clear text
txtValue.Text = ""
'open comm
Call OpenCommPort(MSComm1, Me)
'send read command
arrayByte = ChrB(8) + ChrB(Val(txtAddress.Text))
MSComm1.Output = arrayByte
'enable timer to capture buffer
TimerEEPROM.Enabled = True
End Sub

Private Sub cmdWrite_Click()

'test for address
If Trim(txtAddress.Text) = "" Then
    'msg
    MsgBox "No address has been entered!", vbOKOnly, MBT
    'exit
    Exit Sub
End If

'test for value
If txtValue.Text = "" Then
    'msg
    MsgBox "No value has been entered!", vbOKOnly, MBT
    'exit
    Exit Sub
End If

'open comm
Call OpenCommPort(MSComm1, Me)

'retrieve value
Dim MSB As Double
Dim LSB As Double
MSB = ApplySignWrite(Val(txtValue.Text) \ 256)
LSB = ApplySignWrite(Val(txtValue.Text) And 255)

'build command
arrayByte = ChrB(101) + ChrB(113) + ChrB(Val(txtAddress.Text)) + ChrB(MSB) + ChrB(LSB) + ChrB(170)
'send command
MSComm1.Output = arrayByte
'close comm port
Call CloseCommPort(MSComm1, Me)

End Sub

Private Sub mnuReturn_Click()
'unload screen
Unload Me
End Sub

Private Sub TimerEEPROM_Timer()

'read comm buffer
arrayByte = MSComm1.Input
'disable timer
TimerEEPROM.Enabled = False
'close comm port
Call CloseCommPort(MSComm1, Me)

'test buffer for length
If Not UBound(arrayByte) = 1 Then
    'msg
    MsgBox "EEPROM read failed!", vbOKOnly, MBT
    'exit
    Exit Sub
End If

'check buffer for un-initialized address (65535)
If arrayByte(0) = 255 And arrayByte(1) = 255 Then
    'msg
    MsgBox "EEPROM address " + Trim(Str(Val(txtAddress.Text))) + " is not initialized!", vbOKOnly, MBT
Else
    'prep data and display
    txtValue.Text = ApplySignRead((arrayByte(0) * 256) + arrayByte(1))
End If

End Sub
