VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSCOMM32.OCX"
Begin VB.Form SendSerialNumber 
   Caption         =   "Send Device Serial Number"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   630
   ClientWidth     =   4680
   ControlBox      =   0   'False
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   WindowState     =   2  'Maximized
   Begin VB.Frame fraSerial 
      Caption         =   "Serial Number"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   855
      Left            =   240
      TabIndex        =   0
      Top             =   240
      Width           =   1695
      Begin VB.TextBox txtSerial 
         Height          =   285
         Left            =   240
         Locked          =   -1  'True
         TabIndex        =   1
         Top             =   360
         Width           =   1215
      End
   End
   Begin MSCommLib.MSComm MSComm1 
      Left            =   240
      Top             =   1200
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      DTREnable       =   -1  'True
      InputMode       =   1
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuSample 
         Caption         =   "&Sample"
      End
      Begin VB.Menu mnuReturn 
         Caption         =   "&Return"
      End
   End
End
Attribute VB_Name = "SendSerialNumber"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub mnuReturn_Click()
'unload screen
Unload Me
End Sub

Private Sub mnuSample_Click()
'clear display
txtSerial.Text = ""
'set receive threshold
MSComm1.RThreshold = 5
'open comm
Call OpenCommPort(MSComm1, Me)
'send serial command
arrayByte = ChrB(241)
MSComm1.Output = arrayByte
End Sub

Private Sub MSComm1_OnComm()

'get comm buffer
arrayByte = MSComm1.Input

'test buffer length and header
If Not arrayByte(0) = 241 Or Not UBound(arrayByte) = 4 Then
    'msg
    MsgBox "Serial return failed! Try again.", vbOKOnly, MBT
    'close comm
    Call CloseCommPort(MSComm1, Me)
    'exit sub
    Exit Sub
End If

'test checksum
If CheckSum = False Then
    'msg
    MsgBox "Serial return failed!", vbOKOnly, MBT
    'close comm
    Call CloseCommPort(MSComm1, Me)
    'exit sub
    Exit Sub
End If

'display
txtSerial.Text = MySerial

'close comm
Call CloseCommPort(MSComm1, Me)

End Sub

Private Function CheckSum() As Boolean
On Error GoTo ErrorHandler

'parse
'CDbl to cure overflow error
MyHeader = arrayByte(0)
MySerial = (CDbl(arrayByte(1)) * 256) + arrayByte(2)
MyCheckSum = (CDbl(arrayByte(3)) * 256) + arrayByte(4)

'calc MyCheckSum
TheirCheckSum = MyHeader + MySerial
            
'handle checksum rollover
TheirCheckSum = TheirCheckSum Mod 65536

'compare
If MyCheckSum = TheirCheckSum Then
    CheckSum = True
Else
    CheckSum = False
End If

Exit Function

ErrorHandler:
    CheckSum = False
    Exit Function

End Function


