VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSCOMM32.OCX"
Begin VB.Form EulerAngles 
   Caption         =   "Euler Angles"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   630
   ClientWidth     =   4680
   ControlBox      =   0   'False
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   WindowState     =   2  'Maximized
   Begin VB.Frame fraAngGyro 
      Caption         =   "Euler Angles"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2295
      Left            =   240
      TabIndex        =   0
      Top             =   240
      Width           =   2775
      Begin VB.TextBox txtPitch 
         Height          =   285
         Left            =   360
         Locked          =   -1  'True
         TabIndex        =   3
         Top             =   600
         Width           =   1095
      End
      Begin VB.TextBox txtYaw 
         Height          =   285
         Left            =   360
         Locked          =   -1  'True
         TabIndex        =   2
         Top             =   1200
         Width           =   1095
      End
      Begin VB.TextBox txtRoll 
         Height          =   285
         Left            =   360
         Locked          =   -1  'True
         TabIndex        =   1
         Top             =   1800
         Width           =   1095
      End
      Begin VB.Label Label25 
         AutoSize        =   -1  'True
         Caption         =   "Pitch"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   -1  'True
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   195
         Left            =   360
         TabIndex        =   6
         Top             =   360
         Width           =   450
      End
      Begin VB.Label Label26 
         AutoSize        =   -1  'True
         Caption         =   "Roll"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   -1  'True
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   195
         Left            =   360
         TabIndex        =   5
         Top             =   1560
         Width           =   345
      End
      Begin VB.Label Label27 
         AutoSize        =   -1  'True
         Caption         =   "Yaw"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   -1  'True
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   195
         Left            =   360
         TabIndex        =   4
         Top             =   960
         Width           =   375
      End
   End
   Begin MSCommLib.MSComm MSComm1 
      Left            =   240
      Top             =   2640
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      DTREnable       =   -1  'True
      InputMode       =   1
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuSample 
         Caption         =   "&Sample"
      End
      Begin VB.Menu mnuReturn 
         Caption         =   "&Return"
      End
   End
End
Attribute VB_Name = "EulerAngles"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub mnuReturn_Click()
'unload screen
Unload Me
End Sub

Private Sub mnuSample_Click()
'determine action
If mnuSample.Checked = False Then
    'set check
    mnuSample.Checked = True
    'set receive threshold
    MSComm1.RThreshold = 23
    'open comm
    Call OpenCommPort(MSComm1, Me)
    'send request for gyro matrix
    arrayByte = ChrB(11)
    MSComm1.Output = arrayByte
ElseIf mnuSample.Checked = True Then
    'close comm port
    Call CloseCommPort(MSComm1, Me)
    'set check
    mnuSample.Checked = False
End If
End Sub

Private Sub MSComm1_OnComm()

'get current comm buffer
arrayByte = MSComm1.Input

'test buffer length and header
If Not UBound(arrayByte) = 22 Or Not arrayByte(0) = 11 Then
    'send request for gyro matrix
    arrayByte = ChrB(11)
    MSComm1.Output = arrayByte
    'exit sub
    Exit Sub
End If

'test CheckSum
If CheckSum = False Then
    'send request for gyro matrix
    arrayByte = ChrB(11)
    MSComm1.Output = arrayByte
    'exit sub
    Exit Sub
End If

'calc radians
'pitch radian
If (-MS13 * MS13 + 1) <= 0 Then
    If MS13 > 0 Then
        MyPitch = -PI / 2
    Else
        MyPitch = PI / 2
    End If
Else
    MyPitch = -Atn(MS13 / Sqr(-MS13 * MS13 + 1))
End If
'yaw radian
MyYaw = ATAN2(MS12, MS11)
'roll radian
MyRoll = ATAN2(MS23, MS33)

'calc angles from radians
MyPitch = Round((MyPitch * 180) / PI, 1)
MyYaw = Round((MyYaw * 180) / PI, 1)
MyRoll = Round((MyRoll * 180) / PI, 1)

'display
txtPitch.Text = MyPitch
txtYaw.Text = MyYaw
txtRoll.Text = MyRoll

'send request for gyro matrix
arrayByte = ChrB(11)
MSComm1.Output = arrayByte

End Sub

Private Function CheckSum() As Boolean
On Error GoTo ErrorHandler

'parse
'CDbl to cure overflow error
MyHeader = arrayByte(0)
MS11 = (CDbl(arrayByte(1)) * 256) + arrayByte(2)
MS21 = (CDbl(arrayByte(3)) * 256) + arrayByte(4)
MS31 = (CDbl(arrayByte(5)) * 256) + arrayByte(6)
MS12 = (CDbl(arrayByte(7)) * 256) + arrayByte(8)
MS22 = (CDbl(arrayByte(9)) * 256) + arrayByte(10)
MS32 = (CDbl(arrayByte(11)) * 256) + arrayByte(12)
MS13 = (CDbl(arrayByte(13)) * 256) + arrayByte(14)
MS23 = (CDbl(arrayByte(15)) * 256) + arrayByte(16)
MS33 = (CDbl(arrayByte(17)) * 256) + arrayByte(18)
TimerTicks = (CDbl(arrayByte(19)) * 256) + arrayByte(20)
MyCheckSum = (CDbl(arrayByte(21)) * 256) + arrayByte(22)

'calc MyCheckSum
TheirCheckSum = MyHeader + _
            MS11 + MS21 + MS31 + _
            MS12 + MS22 + MS32 + _
            MS13 + MS23 + MS33 + _
            TimerTicks
            
'handle CheckSum rollover
TheirCheckSum = TheirCheckSum Mod 65536

'compare
If MyCheckSum = TheirCheckSum Then
    'set cs
    CheckSum = True
    'apply sign and scale
    MS11 = ApplySignRead(MS11) / 8192
    MS21 = ApplySignRead(MS21) / 8192
    MS31 = ApplySignRead(MS31) / 8192
    MS12 = ApplySignRead(MS12) / 8192
    MS22 = ApplySignRead(MS22) / 8192
    MS32 = ApplySignRead(MS32) / 8192
    MS13 = ApplySignRead(MS13) / 8192
    MS23 = ApplySignRead(MS23) / 8192
    MS33 = ApplySignRead(MS33) / 8192
    'normalize
    Determinant = MS11 * MS22 * MS33 + MS12 * MS23 * MS31 + MS13 * MS21 * MS32 _
                - MS13 * MS22 * MS31 - MS23 * MS32 * MS11 - MS33 * MS12 * MS21
    'repop
    MS11 = Round(MS11 / Determinant, 4)
    MS21 = Round(MS21 / Determinant, 4)
    MS31 = Round(MS31 / Determinant, 4)
    MS12 = Round(MS12 / Determinant, 4)
    MS22 = Round(MS22 / Determinant, 4)
    MS32 = Round(MS32 / Determinant, 4)
    MS13 = Round(MS13 / Determinant, 4)
    MS23 = Round(MS23 / Determinant, 4)
    MS33 = Round(MS33 / Determinant, 4)
Else
    CheckSum = False
End If

Exit Function

ErrorHandler:
    CheckSum = False
    Exit Function

End Function



